﻿using System;
using System.Collections.Generic;
using HeuristicLab.Random;

namespace HeuristicLab.Problems.Instances.DataAnalysis {
  public class FeynmanInstanceProvider : ArtificialRegressionInstanceProvider {
    public override string Name {
      get { return "Feynman Benchmark Problems"; }
    }

    public override string Description {
      get { return ""; }
    }

    public override Uri WebLink {
      get { return new Uri("https://space.mit.edu/home/tegmark/aifeynman.html"); }
    }

    public override string ReferencePublication {
      get { return "asdf"; }
    }

    public int Seed { get; private set; }

    public FeynmanInstanceProvider() : this((int) DateTime.Now.Ticks) { }

    public FeynmanInstanceProvider(int seed) {
      Seed = seed;
    }

    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
      var descriptorList = new List<IDataDescriptor>();
      var rand           = new MersenneTwister((uint) Seed);
      descriptorList.Add(new Feynman1(rand.Next()));
      descriptorList.Add(new Feynman2(rand.Next()));
      descriptorList.Add(new Feynman3(rand.Next()));
      descriptorList.Add(new Feynman4(rand.Next()));
      descriptorList.Add(new Feynman5(rand.Next()));
      descriptorList.Add(new Feynman6(rand.Next()));
      descriptorList.Add(new Feynman7(rand.Next()));
      descriptorList.Add(new Feynman8(rand.Next()));
      descriptorList.Add(new Feynman9(rand.Next()));
      descriptorList.Add(new Feynman10(rand.Next()));
      descriptorList.Add(new Feynman11(rand.Next()));
      descriptorList.Add(new Feynman12(rand.Next()));
      descriptorList.Add(new Feynman13(rand.Next()));
      return descriptorList;
    }
  }
}